%.$(OBJ_SUFFIX) : %.cpp
	echo $(CXX) -c $<
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) $(INCLUDE) $(DEPGEN_FLAGS) -o $@ -c $<

-include $(OBJECTS:.o=.d)


.PHONY : clean
clean :
ifdef OBJ_SUFFIX
	$(RM) *.$(OBJ_SUFFIX)
endif
	$(RM) core
	$(RM) $(PROGNAME)
ifeq ($(SHELLTYPE), sh)
	@for d in *; \
	do	if test -d $$d; \
		then	if test -e $$d/Makefile; \
			then	make -C $$d $@; \
			fi \
		fi \
	done
endif
ifeq ($(SHELLTYPE), COMMAND.COM)
	-for %%d in ( $(DIRECTORIES) ) do make -C %%d $@
endif


ifeq ($(SHELLTYPE), sh)
.PHONY : touch
touch :
	touch *
	@for d in *; \
	do	if test -d $$d; \
		then	if test -e $$d/Makefile; \
			then	make -C $$d $@; \
			fi \
		fi \
	done
endif
